package jacorb.events;

/** stream-based skeleton class */

public abstract class JacORBEventChannelPOA
	extends org.omg.PortableServer.Servant
	implements org.omg.CORBA.portable.InvokeHandler, jacorb.events.JacORBEventChannelOperations
{
	static private final java.util.Hashtable m_opsHash = new java.util.Hashtable();
	static
	{
		m_opsHash.put ( "destroy", new java.lang.Integer(0));
		m_opsHash.put ( "obtain_push_consumer", new java.lang.Integer(1));
		m_opsHash.put ( "obtain_push_supplier", new java.lang.Integer(2));
		m_opsHash.put ( "obtain_pull_consumer", new java.lang.Integer(3));
		m_opsHash.put ( "for_suppliers", new java.lang.Integer(4));
		m_opsHash.put ( "obtain_pull_supplier", new java.lang.Integer(5));
		m_opsHash.put ( "for_consumers", new java.lang.Integer(6));
	}
	private String[] ids = {"IDL:jacorb/events/JacORBEventChannel:1.0","IDL:omg.org/CosEventChannelAdmin/ConsumerAdmin:1.0","IDL:omg.org/CosEventChannelAdmin/SupplierAdmin:1.0","IDL:omg.org/CosEventChannelAdmin/EventChannel:1.0"};
	public jacorb.events.JacORBEventChannel _this()
	{
		return jacorb.events.JacORBEventChannelHelper.narrow(_this_object());
	}
	public jacorb.events.JacORBEventChannel _this(org.omg.CORBA.ORB orb)
	{
		return jacorb.events.JacORBEventChannelHelper.narrow(_this_object(orb));
	}
	public org.omg.CORBA.portable.OutputStream _invoke(String method, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.ResponseHandler handler)
		throws org.omg.CORBA.SystemException
	{
		org.omg.CORBA.portable.OutputStream _out = null;
		// do something
		org.omg.CORBA.portable.OutputStream out = null;
		// quick lookup of operation
		java.lang.Integer opsIndex = (java.lang.Integer)m_opsHash.get ( method );
		if ( null == opsIndex )
			throw new org.omg.CORBA.BAD_OPERATION(method + " not found");
		switch ( opsIndex.intValue() )
		{
			case 0: // destroy
			{
				_out = handler.createReply();
				destroy();
				break;
			}
			case 1: // obtain_push_consumer
			{
				_out = handler.createReply();
				org.omg.CosEventChannelAdmin.ProxyPushConsumerHelper.write(_out,obtain_push_consumer());
				break;
			}
			case 2: // obtain_push_supplier
			{
				_out = handler.createReply();
				org.omg.CosEventChannelAdmin.ProxyPushSupplierHelper.write(_out,obtain_push_supplier());
				break;
			}
			case 3: // obtain_pull_consumer
			{
				_out = handler.createReply();
				org.omg.CosEventChannelAdmin.ProxyPullConsumerHelper.write(_out,obtain_pull_consumer());
				break;
			}
			case 4: // for_suppliers
			{
				_out = handler.createReply();
				org.omg.CosEventChannelAdmin.SupplierAdminHelper.write(_out,for_suppliers());
				break;
			}
			case 5: // obtain_pull_supplier
			{
				_out = handler.createReply();
				org.omg.CosEventChannelAdmin.ProxyPullSupplierHelper.write(_out,obtain_pull_supplier());
				break;
			}
			case 6: // for_consumers
			{
				_out = handler.createReply();
				org.omg.CosEventChannelAdmin.ConsumerAdminHelper.write(_out,for_consumers());
				break;
			}
		}
		return out;
	}

	public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] obj_id)
	{
		return ids;
	}
}
